#ifndef qbLexerHH
#define qbLexerHH

//#define LEXER_DEBUG

#include <string>

struct LexLocation
{
    int line=0;
    int col =0;
    std::string filename;

public:
    const std::string stringify() const;
    const std::string make_cpp_line() const; // in compile.cc
};

void yyStartFile(FILE *fp, const char *name);
void yyerror(const std::string& msg, const LexLocation& loc);
void yyerror(const std::string& msg);
const LexLocation& yyGetLocation();

extern struct LexerResult
{
    std::string str;
    long double number;
    bool had_sign;
    std::string numtype;
} yylval;

#include "tokens.hh"

extern QBtoken LexerGetToken();

#endif
