tokcase(CHR_S,        "(N)",    R"(
    std::string B_FuncCHR_S(long n) __attribute__((regparm(2)));
    std::string B_FuncCHR_S(long n)
    {
        if(unlikely(n < 0 || n > 255)) B_ERROR(5); // illegal function call"
        return std::string( std::size_t(1), char(n) );
    }
)");
tokcase(HEX_S,        "(N)",    R"(
}
#include <sstream>
namespace
{
    std::string B_FuncHEX_S(BAS_LNG  i)  { std::ostringstream s;  s << std::uppercase << std::hex << (long)i; return s.str(); }
    std::string B_FuncHEX_S(BAS_ULONG i) { std::ostringstream s;  s << std::uppercase << std::hex << (unsigned long)i; return s.str(); }
    std::string B_FuncHEX_S(BAS_SGN i)   { return B_FuncHEX_S(BAS_LNG(std::round(i))); }
    std::string B_FuncHEX_S(BAS_DBL i)   { return B_FuncHEX_S(BAS_LNG(std::round(i))); }
    std::string B_FuncHEX_S(BAS_UINT i)  { return B_FuncHEX_S(BAS_ULONG(i)); }
    std::string B_FuncHEX_S(BAS_UBYTE i) { return B_FuncHEX_S(BAS_ULONG(i)); }
    std::string B_FuncHEX_S(BAS_INT i)   { return B_FuncHEX_S(BAS_LNG(i)); }
    std::string B_FuncHEX_S(BAS_BYTE i)  { return B_FuncHEX_S(BAS_LNG(i)); }
)");
tokcase(OCT_S,        "(N)",    R"(
}
#include <sstream>
namespace
{
    std::string B_FuncOCT_S(BAS_LNG  i)  { std::ostringstream s;  s << std::oct << (long)i; return s.str(); }
    std::string B_FuncOCT_S(BAS_ULONG i) { std::ostringstream s;  s << std::oct << (unsigned long)i; return s.str(); }
    std::string B_FuncOCT_S(BAS_SGN i)   { return B_FuncOCT_S(BAS_LNG(std::round(i))); }
    std::string B_FuncOCT_S(BAS_DBL i)   { return B_FuncOCT_S(BAS_LNG(std::round(i))); }
    std::string B_FuncOCT_S(BAS_UINT i)  { return B_FuncOCT_S(BAS_ULONG(i)); }
    std::string B_FuncOCT_S(BAS_UBYTE i) { return B_FuncOCT_S(BAS_ULONG(i)); }
    std::string B_FuncOCT_S(BAS_INT i)   { return B_FuncOCT_S(BAS_LNG(i)); }
    std::string B_FuncOCT_S(BAS_BYTE i)  { return B_FuncOCT_S(BAS_LNG(i)); }
)");
tokcase(qbcBIN_S,     "(N)",    R"(
    const std::string B_FuncqbcBIN_S(BAS_LNG  i)
    {
        if(i < 0) return "-" + B_FuncqbcBIN_S( BAS_ULONG(-i) );
        return B_FuncqbcBIN_S( BAS_ULONG(i) );
    }
    const std::string B_FuncqbcBIN_S(BAS_ULONG i)
    {
        std::string result;
        do {
            result.insert(std::size_t(0), std::size_t(1), char('0' + (i&1)));
            i >>= 1;
        } while(i);
        return result;
    }
    std::string B_FuncqbcBIN_S(BAS_SGN i)   { return B_FuncqbcBIN_S(BAS_LNG(std::round(i))); }
    std::string B_FuncqbcBIN_S(BAS_DBL i)   { return B_FuncqbcBIN_S(BAS_LNG(std::round(i))); }
    std::string B_FuncqbcBIN_S(BAS_UINT i)  { return B_FuncqbcBIN_S(BAS_ULONG(i)); }
    std::string B_FuncqbcBIN_S(BAS_UBYTE i) { return B_FuncqbcBIN_S(BAS_ULONG(i)); }
    std::string B_FuncqbcBIN_S(BAS_INT i)   { return B_FuncqbcBIN_S(BAS_LNG(i)); }
    std::string B_FuncqbcBIN_S(BAS_BYTE i)  { return B_FuncqbcBIN_S(BAS_LNG(i)); }
)");
tokcase(MKD_S,        "(N)", "");
tokcase(MKI_S,        "(N)", "");
tokcase(MKL_S,        "(N)", "");
tokcase(MKS_S,        "(N)", "");
tokcase(SPACE_S,      "(N)",    R"(
    std::string B_FuncSPACE_S(long n)
    {
        if(unlikely(n < 0)) B_ERROR(5); // illegal function call
        return std::string(n, ' ');
    }
)");
tokcase(STR_S,        "(N)",    R"(
}
#include <sstream>
namespace
{
    std::string B_FuncSTR_S(BAS_DBL d)   { std::ostringstream s; s << ' ' << d; return s.str(); }
    std::string B_FuncSTR_S(BAS_LNG  i)  { return " " + std::to_string(i); }
    std::string B_FuncSTR_S(BAS_ULONG i) { return " " + std::to_string(i); }
    std::string B_FuncSTR_S(BAS_SGN i)   { return B_FuncSTR_S(BAS_DBL(i)); }
    std::string B_FuncSTR_S(BAS_BYTE i)  { return B_FuncSTR_S(BAS_LNG(i)); }
    std::string B_FuncSTR_S(BAS_INT  i)  { return B_FuncSTR_S(BAS_LNG(i)); }
    std::string B_FuncSTR_S(BAS_UBYTE i) { return B_FuncSTR_S(BAS_ULONG(i)); }
    std::string B_FuncSTR_S(BAS_UINT  i) { return B_FuncSTR_S(BAS_ULONG(i)); }
)");
tokcase(LCASE_S,      "(S)",    R"(
    std::string B_FuncLCASE_S(const std::string& s)
    {
        std::string result = s;
        for(std::size_t a=0; a<result.size(); ++a)
            result[a] = std::tolower(result[a]);
        return result;
    }
)");
tokcase(LTRIM_S,      "(S)",    R"(
    std::string B_FuncLTRIM_S(const std::string& s)
    {
        std::size_t p = 0;
        while(p < s.size() && (s[p] == ' ' || s[p] == '\t')) ++p;
        return s.substr(p);
    }
)");
tokcase(RTRIM_S,      "(S)",    R"(
    std::string B_FuncRTRIM_S(const std::string& s)
    {
        std::size_t q = 0; /* Number of chars to eat */
        while(q < s.size() && (s[s.size()-q-1] == ' '
                            || s[s.size()-q-1] == '\t')) ++q;
        return s.substr(0, s.size()-q);
    }
)");
tokcase(UCASE_S,      "(S)",    R"(
    std::string B_FuncUCASE_S(const std::string& s)
    {
        std::string result = s;
        for(std::size_t a=0; a<result.size(); ++a)
            result[a] = std::toupper(result[a]);
        return result;
    }
)");
tokcase(LEFT_S,       "(S,N)",    R"(
    std::string B_FuncLEFT_S(const std::string& s, long count)
    {
        if(unlikely(count < 0)) B_ERROR(5);
        if((std::size_t)count >= s.size()) return s;
        return s.substr(0, count);
    }
)");
tokcase(RIGHT_S,      "(S,N)",    R"(
    std::string B_FuncRIGHT_S(const std::string& s, long count)
    {
        if(unlikely(count < 0)) B_ERROR(5);
        if((std::size_t)count >= s.size()) return s;
        return s.substr(s.size()-count, count);
    }
)");
tokcase(STRING_S,     "(N,S)"
                      "|"
                      "(N,N)",   R"(
    std::string B_FuncSTRING_S(long n, const std::string& s)
    {
        if(unlikely(s.empty())) B_ERROR(5); // illegal function call
        return std::string(n, s[0]);
    }
    std::string B_FuncSTRING_S(long n, int i)
    {
        if(unlikely(i < 0 || i > 255)) B_ERROR(5); // illegal function call
        return std::string(n, (char) i);
    }
)");
tokcase(MID_S,        "(S,N?,N)",   R"(
    std::string B_FuncMID_S(const std::string& s, int pos, int count)
    {
        if(unlikely(pos <= 0 || count < 0)) B_ERROR(5);
        if((size_t)pos > s.size()) return {};
        return s.substr(pos-1, count);
    }
)");

     // implied -> string functions
tokcase(DATE_S,       "",    Func_DATES_Common);
tokcase(TIME_S,       "",    Func_TIMES_Common);
tokcase(INKEY_S,      "", "")
tokcase(COMMAND_S,    "",    R"(
    const std::string& B_FuncCOMMAND_S()
    {
        return B_CmdLine;
    }
)");
     // any -> string functions
tokcase(ENVIRON_S,    "(S)"
                      "|"
                      "(N)",   R"(
}
#include <unistd.h> // environ
namespace
{
    std::string B_FuncENVIRON_S(int index) // Note: In QuickBASIC, the valid range for this parameter is 1-255.
    {
    	if(index <= 0) B_ERROR(5); // illegal function call
    	auto p = environ;
    	for(; index > 1 && *p; --index) ++p;
    	return *p ? *p : "";
    }
    std::string B_FuncENVIRON_S(const std::string& key)
    {
        auto s = std::getenv(key.c_str());
        return s ? s : "";
    }
)");
     // var_ref -> string
tokcase(VARPTR_S,     "(V)",   R"(
    const std::string B_FuncVARPTR_S(int typetag, unsigned long offs)
    {
        std::string result(1, (char)typetag); 
        for(unsigned n=0; n<sizeof(offs); ++n)
        {
            result += (char)( (offs >> (n*8)) & 0xFF );
        }
        return result;
    }
    std::string B_FuncVARPTR_S(const BAS_BYTE& s) { return B_FuncVARPTR_S(VARPTR_TAG_BYTE, B_FuncVARPTR(s)); }
    std::string B_FuncVARPTR_S(const BAS_UBYTE& s) { return B_FuncVARPTR_S(VARPTR_TAG_UBYTE, B_FuncVARPTR(s)); }
    std::string B_FuncVARPTR_S(const BAS_INT& s) { return B_FuncVARPTR_S(VARPTR_TAG_INT, B_FuncVARPTR(s)); }
    std::string B_FuncVARPTR_S(const BAS_UINT& s) { return B_FuncVARPTR_S(VARPTR_TAG_UINT, B_FuncVARPTR(s)); }
    std::string B_FuncVARPTR_S(const BAS_SGN& s) { return B_FuncVARPTR_S(VARPTR_TAG_SGN, B_FuncVARPTR(s)); }
    std::string B_FuncVARPTR_S(const BAS_DBL& s) { return B_FuncVARPTR_S(VARPTR_TAG_DBL, B_FuncVARPTR(s)); }
    std::string B_FuncVARPTR_S(const BAS_LNG& s) { return B_FuncVARPTR_S(VARPTR_TAG_LNG, B_FuncVARPTR(s)); }
    std::string B_FuncVARPTR_S(const BAS_ULONG& s) { return B_FuncVARPTR_S(VARPTR_TAG_ULONG, B_FuncVARPTR(s)); }
    std::string B_FuncVARPTR_S(const std::string& s) { return B_FuncVARPTR_S(VARPTR_TAG_STR, B_FuncVARPTR(s)); }
)");

     // other
tokcase(INPUT_S,      "(N?,f)", (std::initializer_list<std::string>{ Stream_Common, Console_Common, R"(

    std::string B_FuncINPUT_S(int n)                 { return GET_STDIN().Input_N(n); }
    std::string B_FuncINPUT_S(int n, int filenumber) { return GET_STREAM_INPUT(filenumber).Input_N(n); }

)"} ) );


