template<typename A>
class RptPa: public parser<RptPa<A> >
{
    typedef parser<RptPa<A> > base_t;
    const unsigned min;
    const unsigned trail;
    const A opt;
public:
    RptPa(unsigned mi,unsigned ma,const parser<A>& a)
        : base_t(), min(mi),trail(ma-mi), opt(a.derived()) { }
    template<typename ScannerT>
    bool parse(ScannerT& scan) const
    {
        typename ScannerT::iterator begin = scan.pos();
        for(unsigned a=0; a<min; ++a)
                if(!opt.parse(scan)) { scan.revert(begin); return false; }
        for(unsigned a=0; a<trail; ++a)
                if(!opt.parse(scan)) break;
        return true;
    }
    const std::string what() const
    {
        return opt.what();
    }
};
class repeat_p
{
    unsigned min,max;
public:
    repeat_p(unsigned mi,unsigned ma) : min(mi), max(ma) { }

    template<typename A>
    RptPa<A> operator[] (const parser<A>& a) const
    {
        return RptPa<A> (min,max,a.derived());
    }
};
